unit bVmesnik;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, dijkAlg, tGraf, ExtCtrls;

type
  besVoz=class (dijkVoz)
    beseda: string; //za razlikovanje vozlisc
  end;
  besGraf=class (dijkGraf)
    procedure trenutno (trenutnoVoz: dijkVoz; trenutnaPov: povezava); override; //izpise graf z oznacenima zacetnim in koncnim vozliscem trenutnega koraka
    procedure izpis (memo: tMemo); //izpise graf v memo <memo>
  end;
  TpodlagaBVmesnik = class(TForm)
    mem: TMemo;
    btDodVoz: TButton;
    btDodPov: TButton;
    btBrisiVoz: TButton;
    btBrisiPov: TButton;
    edVoz: TEdit;
    edOd: TEdit;
    lblVoz: TLabel;
    lblOd: TLabel;
    lblDo: TLabel;
    edDo: TEdit;
    btIzhod: TButton;
    lblPovezava: TLabel;
    lblDolzina: TLabel;
    btIzprazni: TButton;
    edDolzina: TEdit;
    btDijkstraCel: TButton;
    btDijkstraKorak: TButton;
    procedure FormCreate(Sender: TObject);
    procedure btIzhodClick(Sender: TObject);
    procedure btDodVozClick(Sender: TObject);
    procedure btDodPovClick(Sender: TObject);
    procedure btBrisiPovClick(Sender: TObject);
    procedure btBrisiVozClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btIzprazniClick(Sender: TObject);
    procedure btDijkstraCelClick(Sender: TObject);
    procedure btDijkstraKorakClick(Sender: TObject);
  private
    { Private declarations }
  public
    enGraf: besGraf;
    vozDijkKorak: vozlisce;
    seEnkrat: boolean;
  end;

var
  podlagaBVmesnik: TpodlagaBVmesnik;

implementation

{$R *.DFM}

procedure besGraf.trenutno (trenutnoVoz: dijkVoz; trenutnaPov: povezava);
  var bes1, bes2: string;
begin
  bes1:=besVoz (trenutnoVoz).beseda;
  besVoz (trenutnoVoz).beseda:='[Od: '+bes1+']';
  bes2:=besVoz (trenutnaPov.kam).beseda;
  besVoz (trenutnaPov.kam).beseda:='[Do: '+bes2+']';
  izpis (podlagaBVmesnik.mem);
  besVoz (trenutnoVoz).beseda:=bes1;
  besVoz (trenutnaPov.kam).beseda:=bes2;
  podlagaBVmesnik.mem.lines.add ('-----------');
end;

procedure besGraf.izpis (memo: tMemo);
  var
    voz: vozlisce;
    pov: povezava;
    vrsta, crta: string;
begin
  voz:=prvoVoz;
  while voz<>nil do begin
    pov:=voz.prvaPov;
    vrsta:=besVoz (voz).beseda+' ('+floatToStr (besVoz (voz).odZac)+')';
    while pov<>nil do begin
      if besVoz (pov.kam).predhodnik=voz then crta:='==' else crta:='--';
      vrsta:=vrsta+crta+floatToStr (pov.dolzina)+crta+'>'+besVoz (pov.kam).beseda+' ('+floatToStr (besVoz (pov.kam).odZac)+')';
      pov:=pov.naslednja;
    end;
    memo.lines.add (vrsta);
    voz:=voz.naslednje;
  end;
end;

procedure TpodlagaBVmesnik.FormCreate(Sender: TObject);
begin
  podlagaBVmesnik.scaleBy (120, pixelsPerInch);
  enGraf:=besGraf.create;
end;

procedure TpodlagaBVmesnik.btIzhodClick(Sender: TObject);
begin
  podlagaBVmesnik.close;
end;

procedure TpodlagaBVmesnik.btDodVozClick(Sender: TObject);
  var voz: besVoz;
begin
  voz:=besVoz.create;
  voz.beseda:=edVoz.text;
  enGraf.dodajVoz (voz);
  mem.clear;
  enGraf.izpis (mem);
end;

procedure TpodlagaBVmesnik.btDodPovClick(Sender: TObject);
  var voz1, voz2: vozlisce;
begin
  voz1:=enGraf.prvoVoz;
  while (voz1<>nil) and (besVoz (voz1).beseda<>edOd.text) do voz1:=voz1.naslednje;
  voz2:=enGraf.prvoVoz;
  while (voz2<>nil) and (besVoz (voz2).beseda<>edDo.text) do voz2:=voz2.naslednje;
  if (voz1<>nil) and (voz2<>nil) then voz1.dodajPov (voz2, strToFloat (edDolzina.text));
  mem.clear;
  enGraf.izpis (mem);
end;

procedure TpodlagaBVmesnik.btBrisiPovClick(Sender: TObject);
  var voz1, voz2: vozlisce;
begin
  voz1:=enGraf.prvoVoz;
  while (voz1<>nil) and (besVoz (voz1).beseda<>edOd.text) do voz1:=voz1.naslednje;
  voz2:=enGraf.prvoVoz;
  while (voz2<>nil) and (besVoz (voz2).beseda<>edDo.text) do voz2:=voz2.naslednje;
  if (voz1<>nil) and (voz2<>nil) then voz1.brisiPov (voz2);
  mem.clear;
  enGraf.izpis (mem);
end;

procedure TpodlagaBVmesnik.btBrisiVozClick(Sender: TObject);
  var voz: vozlisce;
begin
  voz:=enGraf.prvoVoz;
  if besVoz (voz).beseda=edVoz.text then enGraf.brisiNVoz (nil) else begin
    while (voz.naslednje<>nil) and (besVoz (voz.naslednje).beseda<>edVoz.text) do voz:=voz.naslednje;
    if voz.naslednje<>nil then enGraf.brisiNVoz (voz);
  end;
  mem.clear;
  enGraf.izpis (mem);
end;

procedure TpodlagaBVmesnik.FormDestroy(Sender: TObject);
begin
  enGraf.free;
end;

procedure TpodlagaBVmesnik.btIzprazniClick(Sender: TObject);
begin
  enGraf.free;
  enGraf:=besGraf.create;
  mem.clear;
end;

procedure TpodlagaBVmesnik.btDijkstraCelClick(Sender: TObject);
  var voz: vozlisce;
begin
  voz:=enGraf.prvoVoz;
  while (voz<>nil) and (besVoz (voz).beseda<>edVoz.text) do voz:=voz.naslednje;
  mem.clear;
  if voz<>nil then enGraf.dijkstraCel (voz);
  enGraf.izpis (mem);
end;

procedure TpodlagaBVmesnik.btDijkstraKorakClick(Sender: TObject);
begin
  if vozDijkKorak=nil then begin
    vozDijkKorak:=enGraf.prvoVoz;
    while (vozDijkKorak<>nil) and (besVoz (vozDijkKorak).beseda<>edVoz.text) do vozDijkKorak:=vozDijkKorak.naslednje;
    if vozDijkKorak<>nil then begin
      mem.clear;
      seEnkrat:=true;
    end;
  end;
  if (vozDijkKorak<>nil) and (seEnkrat) then seEnkrat:=enGraf.dijkstraKorak (vozDijkKorak);
  if vozDijkKorak<>nil then enGraf.izpis (mem);
  if seEnkrat then podlagaBVmesnik.mem.lines.add ('-----------') else begin
    podlagaBVmesnik.mem.lines.add ('---KONEC---');
    vozDijkKorak:=nil;
  end;
end;

end.
