unit gVmesnik;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls, StdCtrls, dijkAlg, tGraf;

const maxVoz=8; //najvecje stevilo vozlisc

type
  stVoz=class (dijkVoz)
    stevilka, x, y: integer; //polozaj vozlisca na zaslonu
  end;
(*  lin=record
     k, n:integer;
  end;*)
  stGraf=class (dijkGraf)
    steviloVoz: integer; //stevilo vozlisc v grafu
    function nalozi (imeDat: string): boolean; //nalozi graf iz datoteke z imenom <imeDat>; ce ime ne obstaja, vrne false, sicer pa true
    procedure shrani (imeDat: string); //shrani graf v datoteko z imenom imeDat
    procedure dodajVoz (voz: stVoz);
    procedure trenutno (trenutnoVoz: dijkVoz; trenutnaPov: povezava); override;
    procedure izris (podlaga: tForm); //izrise graf na formo <podlaga>
(*    function LinearnaF(x1, y1, x2, y2:integer):lin;*)
  end;
  TpodlagaGVmesnik = class(TForm)
    pum: TPopupMenu;
    pumDodajVoz: TMenuItem;
    pan: TPanel;
    edZac: TEdit;
    edKon: TEdit;
    edRazdalja: TEdit;
    lblZac: TLabel;
    lblKon: TLabel;
    lblRazdalja: TLabel;
    pumDodajPov: TMenuItem;
    pumIzhod: TMenuItem;
    pumBrisiGraf: TMenuItem;
    pumShrani: TMenuItem;
    pumNalozi: TMenuItem;
    lblDat: TLabel;
    edDat: TEdit;
    btVRedu: TButton;
    btPreklic: TButton;
    pumBrisiPov: TMenuItem;
    pumDijkstra: TMenuItem;
    btNaprej: TButton;
    pumDijkstraPK: TMenuItem;
    btIzvedi: TButton;
    btPreglej: TButton;
    dlgOdpri: TOpenDialog;
    dlgShrani: TSaveDialog;
    procedure prikazDat (prikazi: boolean);
    procedure pumDodajVozClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure pumIzhodClick(Sender: TObject);
    procedure pumDodajPovClick(Sender: TObject);
    procedure pumBrisiGrafClick(Sender: TObject);
    procedure pumShraniNaloziClick(Sender: TObject);
    procedure btVReduClick(Sender: TObject);
    procedure btPreklicClick(Sender: TObject);
    procedure btIzvediClick(Sender: TObject);
    procedure pumDijkstraClick(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormPaint(Sender: TObject);
    procedure pumBrisiPovClick(Sender: TObject);
    procedure btNaprejClick(Sender: TObject);
    procedure btPreglejClick(Sender: TObject);
  private
    { Private declarations }
  public
    enGraf: stGraf;
    shrani: boolean;
    poKorakih: boolean;
    vozKorak: vozlisce;
    seEnkrat: boolean;
  end;

var
  podlagaGVmesnik: TpodlagaGVmesnik;

implementation

uses vizitka;

{$R *.DFM}

function stGraf.nalozi (imeDat: string): boolean;
  var
    i: integer;
    dat: textFile;
    voz1, voz2: vozlisce;
    vrsta, st1, st2: string;
begin
  if fileExists (imeDat) then begin
    assignFile (dat, imeDat); //odpre datoteko
    reset (dat);
    readln (dat, vrsta); //prebere stevilo vozlisc
    for i:=1 to strToInt (vrsta) do begin //naredi vozlisca
      voz1:=stVoz.create;
      dodajVoz (stVoz (voz1));
    end;
    for i:=1 to steviloVoz do begin //gre po vseh vozliscih
      readln (dat, vrsta);
      st1:=copy (vrsta, 1 , pos (':', vrsta)-1);
      vrsta:=copy (vrsta, length (st1)+2, length (vrsta)-length (st1)-1);
      voz1:=prvoVoz;
      while stVoz (voz1).stevilka<>strToInt (st1) do voz1:=voz1.naslednje; //poisce vozlisce s trenutno stevilko
      while vrsta<>'' do begin //gre po vseh povezavah
        st1:=copy (vrsta, 1 , pos (',', vrsta)-1); //prebere podatke o povezavi
        vrsta:=copy (vrsta, length (st1)+2, length (vrsta)-length (st1)-1);
        st2:=copy (vrsta, 1 , pos (';', vrsta)-1);
        vrsta:=copy (vrsta, length (st2)+2, length (vrsta)-length (st2)-1);
        voz2:=prvoVoz;
        while stVoz (voz2).stevilka<>strToInt (st1) do voz2:=voz2.naslednje; //vozlisce s trenutno stevilko
        voz1.dodajPov (voz2, strToFloat (st2)); //doda povezavo do njega
      end;
    end;
    closeFile (dat);
    nalozi:=true;
  end else nalozi:=false;
end;

procedure stGraf.shrani (imeDat: string);
  var
    dat: textFile;
    voz: vozlisce;
    pov: povezava;
    vrsta: string;
begin
  assignFile (dat, imeDat); //odpre datoteko
  rewrite (dat);
  writeln (dat, steviloVoz); //zapise stavilo vozlisc
  voz:=prvoVoz;
  while voz<>nil do begin //gre po vseh vozliscih
    pov:=voz.prvaPov;
    vrsta:=intToStr (stVoz (voz).stevilka)+':';
    while pov<>nil do begin //gre po vseh povezavah
      vrsta:=vrsta+intToStr (stVoz (pov.kam).stevilka)+','+floatToStr (pov.dolzina)+';'; //zapise podatke o povezavi
      pov:=pov.naslednja;
    end;
    writeln (dat, vrsta);
    voz:=voz.naslednje;
  end;
  closeFile (dat);
end;

procedure stGraf.dodajVoz (voz: stVoz);
var
  i:integer;
  pomVoz: vozlisce;
begin
  inc (steviloVoz);
  voz.stevilka:=steviloVoz;
  inherited dodajVoz (voz);
  pomVoz:=prvoVoz;
  for i:=1 to steviloVoz do begin //popravi polozaje vozlisc na zaslonu
    stVoz (pomVoz).x:=round ((cos(i*2*Pi/steviloVoz-Pi/2)*150)+200);
    stVoz (pomVoz).y:=round ((sin(i*2*Pi/steviloVoz-Pi/2)*150)+200);
    pomVoz:=pomVoz.naslednje;
  end;
end;

procedure stGraf.trenutno (trenutnoVoz: dijkVoz; trenutnaPov: povezava);
begin
end;

procedure stGraf.izris (podlaga: tForm);
  var
    xNapis, yNapis: integer;
    voz: vozlisce;
    pov: povezava;
(*    funk:lin;*)
(*    x1, y1, x2, y2:integer;*)
begin
  podlaga.canvas.rectangle(30, 30, 420, 420); //ozadje
  voz:=prvoVoz;
  while voz<>nil do begin //gre po vseh vozliscih
    pov:=voz.prvaPov;
    while pov<>nil do begin //gre po vseh povezavah
      podlaga.canvas.moveTo (stVoz (voz).x+25, stVoz (voz).y+25);
      if stVoz (pov.kam).predhodnik=voz then podlaga.canvas.pen.color:=clRed; //ce je povezava najkrajsa del kake najkrajse poti
      podlaga.canvas.lineTo (stVoz (pov.kam).x+25, stVoz (pov.kam).y+25); //narise povezavo
      podlaga.canvas.pen.color:=clBlack;
      xNapis:=(stVoz (voz).x+stVoz (pov.kam).x) div 2; //podatke o njej izpise na sredino crte
      yNapis:=(stVoz (voz).y+stVoz (pov.kam).y) div 2;
      if stVoz (voz).y=stVoz (pov.kam).y then xNapis:=(xNapis+stVoz (voz).x) div 2 else yNapis:=(yNapis+stVoz (voz).y+8) div 2; //da se izpisi povezav obe smeri ne prekrivajo
      podlaga.canvas.textOut (xNapis, yNapis, intToStr (stVoz (voz).stevilka)+'>'+intToStr (stVoz (pov.kam).stevilka)+' ('+floatToStr (pov.dolzina)+')'); //izpise podatke o povezavi
      pov:=pov.naslednja;
    end;
    voz:=voz.naslednje;
  end;
  podlaga.canvas.brush.color:=clWhite; //doloci barvo kroga
  podlaga.canvas.brush.style:=bsSolid;
  voz:=prvoVoz;
  while voz<>nil do begin  //gre po vseh vozliscih
    if voz=zadnjeVoz then podlaga.canvas.pen.color:=clBlue; //ce je vozlisce trenutno v koracnem Dijkstrovem algoritmu
    podlaga.canvas.ellipse (stVoz (voz).x, stVoz (voz).y, stVoz (voz).x+50, stVoz (voz).y+50); //narise vozlisce
    podlaga.canvas.pen.color:=clBlack;
    podlaga.canvas.textOut (stVoz (voz).x+15, stVoz (voz).y-18, intToStr (stVoz (voz).stevilka)); //izpise podatke o njem
    podlaga.canvas.textOut (stVoz (voz).x+18, stVoz (voz).y+18, floatToStr (stVoz (voz).odZac));
    voz:=voz.naslednje;
  end;
end;

(*function stGraf.LinearnaF(x1, y1, x2, y2:integer):lin;
var k:integer;
begin
     if (x2-x1)<>0 then
     k:=(y2-y1) div (x2-x1)
     else k:=0;
     LinearnaF.k:=k;
     LinearnaF.n:=y1-x1*k;
end;*)

procedure tPodlagaGVmesnik.prikazDat (prikazi: boolean); //prikaze/skrije stvari za delo z datotekami
begin
  lblDat.visible:=prikazi;
  edDat.visible:=prikazi;
  btVRedu.visible:=prikazi;
  btPreklic.visible:=prikazi;
  btPreglej.visible:=prikazi;
end;

procedure TpodlagaGVmesnik.pumDodajVozClick(Sender: TObject); //klik na meni za dodajanje vozlisca
  var voz: stVoz;
begin
  if enGraf.steviloVoz<=MaxVoz then begin
    voz:=stVoz.create;
    enGraf.dodajVoz (voz);
    enGraf.izris (podlagaGVmesnik);
  end else showMessage ('Napaka #9: presezeno najvecje stevilo vozlisc.');
end;

procedure TpodlagaGVmesnik.FormCreate(Sender: TObject); //ko se program pozene
begin
(*  podlagaGVmesnik.Top:=10; //STVAR JE TAKO ALI TAKO CENTRIRANA
  podlagaGVmesnik.Left:=10;*)
  podlagaGVmesnik.scaleBy (96, pixelsPerInch);
  enGraf:=stGraf.create;
end;

procedure TpodlagaGVmesnik.pumIzhodClick(Sender: TObject); //klik na meni za izhod
begin
  podlagaGVmesnik.close;
end;

procedure TpodlagaGVmesnik.pumDodajPovClick(Sender: TObject); //klik na meni za dodajanje povezave
  var voz1, voz2: vozlisce;
begin
  if (edzac.text<>'') and (edkon.text<>'') and (edrazdalja.text<>'') then begin
    voz1:=enGraf.prvoVoz;
    while (voz1<>nil) and (stVoz (voz1).stevilka<>strToInt (edZac.text)) do voz1:=voz1.naslednje;
    voz2:=enGraf.prvoVoz;
    while (voz2<>nil) and (stVoz (voz2).stevilka<>strToInt (edKon.text)) do voz2:=voz2.naslednje;
    if (voz1<>nil) and (voz2<>nil) and (edRazdalja.text<>'') then begin
     if not voz1.dodajPov (voz2, strToFloat (edRazdalja.text)) then showMessage ('Napaka #1: povezava ze obstaja.')
    end else showMessage ('Napaka #2: eno od vozlisc ne obstaja.');
    enGraf.izris (podlagaGVmesnik);
  end else ShowMessage('Napaka #7: manjkajo podatki o vozliscih ali razdalji.');
end;

procedure TpodlagaGVmesnik.pumBrisiGrafClick(Sender: TObject); //klik na meni za brisanje grafa
begin
  enGraf.free;
  enGraf:=stGraf.create;
  enGraf.izris (podlagaGVmesnik);
end;

procedure TpodlagaGVmesnik.pumShraniNaloziClick(Sender: TObject); //klik na meni za nalaganje grafa
begin
  if sender=pumShrani then shrani:=true else shrani:=false;
  prikazDat (true);
end;

procedure TpodlagaGVmesnik.btVReduClick(Sender: TObject);
begin
  if shrani then begin
    if pos ('.', edDat.text)=0 then edDat.text:=edDat.text+'.mbg';
    enGraf.shrani (edDat.text);
    caption:='Dijkstra GUI ['+edDat.text+']';
  end else begin
    enGraf.free;
    enGraf:=stGraf.create;
    if enGraf.nalozi (edDat.text) then begin
      caption:='Dijkstra GUI ['+edDat.text+']';
      enGraf.izris (podlagaGVmesnik);
        btPreglej.visible:=false;
    end else showMessage ('Napaka #6: datoteka ne obstaja.');
  end;
  prikazDat (false);
  btPreglej.visible:=false;
end;

procedure TpodlagaGVmesnik.btPreklicClick(Sender: TObject); //ce si premislimo o delu z datotekami
begin
  prikazDat (false);
  btPreglej.visible:=false;
end;

procedure TpodlagaGVmesnik.btIzvediClick(Sender: TObject); //klik na gumb za zacetek izvajanja Dijkstrovega algoritma
begin
if (edZac.text<>'') then begin
  vozKorak:=enGraf.prvoVoz;
  while (vozKorak<>nil) and (stVoz (vozKorak).stevilka<>strToInt (edZac.text)) do vozKorak:=vozKorak.naslednje;
  if vozKorak<>nil then
    if poKorakih then begin
      btNaprej.show;
      lblZac.hide;
      edZac.hide;
      seEnkrat:=enGraf.dijkstraKorak (vozKorak);
    end else begin
      enGraf.dijkstraCel (vozKorak);
      lblKon.show;
      lblRazdalja.show;
      edKon.show;
      edRazdalja.show;
    end
  else showMessage ('Napaka #5: vozlisce ne obstaja.');
  enGraf.izris (podlagaGVmesnik);
  btIzvedi.hide;
  edZac.text:='';
end
else showmessage('Napaka #8: napacno zacetno vozlisce.');
end;

procedure TpodlagaGVmesnik.pumDijkstraClick(Sender: TObject); //klik ne meni za Dijkstrov algoritem
  var
    voz: vozlisce;
    pov: povezava;
begin
  if sender=pumDijkstraPK then poKorakih:=true else poKorakih:=false;
  voz:=enGraf.prvoVoz;
  while (voz<>nil) and (stVoz (voz).stevilka<>1) do voz:=voz.naslednje;
  if voz<>nil then begin
    pov:=voz.prvaPov;
    while (pov<>nil) and (pov.kam<>voz) do pov:=pov.naslednja;
    if pov<>nil then if pov.dolzina=1 then podlagaVizitka.show;
  end;
  lblKon.hide;
  lblRazdalja.hide;
  edKon.hide;
  edRazdalja.hide;
  btIzvedi.show;
end;

procedure TpodlagaGVmesnik.FormMouseDown(Sender: TObject; //klik kjekoli na formi
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  pum.popup (x+podlagaGVmesnik.left, y+podlagaGVmesnik.top);
end;

procedure TpodlagaGVmesnik.FormPaint(Sender: TObject); //kadar formo kaj prekrije
begin
  enGraf.izris (podlagaGVmesnik);
end;

procedure TpodlagaGVmesnik.pumBrisiPovClick(Sender: TObject); //klik na meni za brisanje povezave
  var voz1, voz2: vozlisce;
begin
  voz1:=enGraf.prvoVoz;
  while (voz1<>nil) and (stVoz (voz1).stevilka<>strToInt (edZac.text)) do voz1:=voz1.naslednje;
  voz2:=enGraf.prvoVoz;
  while (voz2<>nil) and (stVoz (voz2).stevilka<>strToInt (edKon.text)) do voz2:=voz2.naslednje;
  if (voz1<>nil) and (voz2<>nil) then begin
    if not voz1.brisiPov (voz2) then showmessage ('Napaka #3: povezava ne obstaja.');
  end else showmessage ('Napaka #4: eno od vozlisc ne obstaja.');
  enGraf.izris (podlagaGVmesnik);
end;

procedure TpodlagaGVmesnik.btNaprejClick(Sender: TObject); //klik ne gumb za naslednji korak koracnega Dijksrovega algoritma
begin
  if seEnkrat then begin
    seEnkrat:=enGraf.dijkstraKorak (vozKorak);
    if not seEnkrat then btNaprej.caption:='Koncaj';
  end else begin
    lblZac.show;
    lblKon.show;
    lblRazdalja.show;
    edzac.show;
    edKon.show;
    edRazdalja.show;
    btNaprej.hide;
    enGraf.zadnjeVoz:=nil;
  end;
  enGraf.izris (podlagaGVmesnik);
end;

procedure TpodlagaGVmesnik.btPreglejClick(Sender: TObject); //klik na gumb za prikaz okna z direktoriji in datotekmi
begin
  if shrani then begin
    if dlgShrani.execute then edDat.text:=dlgShrani.fileName;
  end else
    if dlgOdpri.execute then edDat.text:=dlgOdpri.fileName;
end;

end.
