unit tPrVrsta;

interface

const
  zacStEl=100; //najvecje stevilo elementov v vrsti na zacetku
  dodStEl=50; //stevilo, za katero se najvecje stevilo elementov v vrsti poveca, ko se vrsta napolni

type
  element=class
    prioriteta: real; //manjsa stevilka pomeni vecjo prioriteto
    indeks: integer; //indeks elementa v polju
  end;
  prVrsta=class
    polje: array of element; //polje, kjer so shranjeni elementi vrste (na mestu 0 ni nicesar)
    stEl: integer; //stevilo elementov v vrsti
    constructor create;
    destructor destroy; override;
    procedure dodaj (el: element); //v vrsto vstavi element <el>
    procedure znizajPr (el: element; novaPr: real); //elementu <el> zniza prioriteto na <novaPr>
    function brisiMin: element; //zbrise in vrne element z najnizjo prioriteto
  end;

implementation

constructor prVrsta.create;
begin
  inherited;
  setLength (polje, zacStEl); //doloci zacetno dolzino polja z elementi
end;

destructor prVrsta.destroy;
  var n: integer;
begin
  for n:=1 to stEl do polje [n].free; //gre po vseh elementih in jih sprosti
  inherited;
end;

procedure prVrsta.dodaj (el: element);
  var indNovi, indStars: integer;
begin
  inc (stEl);
  if stEl>=length (polje) then setLength (polje, length (polje)+dodStEl); //ce je polje z elementi premajhno, ga poveca
  indNovi:=stEl; //indeks novega da na konec polja
  indStars:=indNovi div 2; //doloci indeks njegovega starsa
  while (indStars>0) and (el.prioriteta<polje [indStars].prioriteta) do begin //dokler ne pridemo do vrha kopice ali dokler nima stars vecje priorite od dodajanega
    polje [indNovi]:=polje [indStars]; //starsa prestavi na mesto dodajanega
    polje [indNovi].indeks:=indNovi;
    indNovi:=indStars; //indeksu dodajanega priredi indeks starsa
    indStars:=indNovi div 2; //doloci novega starsa
  end;
  polje [indNovi]:=el;
  polje [indNovi].indeks:=indNovi;
end;

procedure prVrsta.znizajPr (el: element; novaPr: real);
  var indPrestavljani, indStars: integer;
begin
  el.prioriteta:=novaPr;
  indPrestavljani:=el.indeks; //doloci indeks prestavljanega
  indStars:=indPrestavljani div 2; //doloci indeks njegovega starsa
  while (indStars>0) and (el.prioriteta<polje [indStars].prioriteta) do begin  //dokler ne pridemo do vrha kopice ali dokler nima stars vecje priorite od prestavljanega
    polje [indPrestavljani]:=polje [indStars]; //starsa prestavi na mesto prestavljanega
    polje [indPrestavljani].indeks:=indPrestavljani;
    indPrestavljani:=indStars; //indeksu prestavljanega priredi indeks starsa
    indStars:=indPrestavljani div 2; //doloci novega starsa
  end;
  polje [indPrestavljani]:=el;
  polje [indPrestavljani].indeks:=indPrestavljani;
end;

function prVrsta.brisiMin: element;
  var indPrestavljani, indSin: integer;
begin
  if stEl>0 then begin
    brisiMin:=polje [1];
    if stEl>1 then begin
      indPrestavljani:=1; //doloci mesto, kamor mora prestaviti nek element
      if (stEl>2) and (polje [3].prioriteta<polje [2].prioriteta) then //poisce sina z vecjo prioriteto
        indSin:=3 else indSin:=2;
      while (2*indPrestavljani<=stEl) and (polje [indSin].prioriteta<polje [stEl].prioriteta) do begin //dokler ne zmanjka elementov ali dokler nima sin vecje prioritete od zadnjega (za katerega se delamo, da ga damo namesto brisanega)
        polje [indPrestavljani]:=polje [indSin]; //sina prestavi na mesto prestavljanega
        polje [indPrestavljani].indeks:=indPrestavljani;
        indPrestavljani:=indSin; //indeksu prestavljanega priredi indeks sina
        if (stEl>=2*indPrestavljani+1) and (polje [2*indPrestavljani+1].prioriteta<polje [2*indPrestavljani].prioriteta) then //doloci novega sina z vecjo prioriteto
          indSin:=2*indPrestavljani+1 else indSin:=2*indPrestavljani;
      end;
      polje [indPrestavljani]:=polje [stEl];
      polje [indPrestavljani].indeks:=indPrestavljani;
    end;
    dec (stEl);
  end else brisiMin:=nil;
end;

end.
