unit testPrVr;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, tPrVrsta, math;

type
  testPrVrsta=class (prVrsta)
    procedure izpis (memo: tMemo); //izpise prioritetno vrsto v memo <memo>
  end;
  TpodlagaPrVrsta = class(TForm)
    lblPrioriteta: TLabel;
    lblBrisal: TLabel;
    edBrisal: TEdit;
    btDodaj: TButton;
    btBrisi: TButton;
    mem: TMemo;
    btZnizajPr: TButton;
    lblNovaPr: TLabel;
    edPrioriteta: TEdit;
    edNovaPr: TEdit;
    btIzprazni: TButton;
    procedure btDodajClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btBrisiClick(Sender: TObject);
    procedure btZnizajPrClick(Sender: TObject);
    procedure btIzprazniClick(Sender: TObject);
  private
    { Private declarations }
  public
     enaVrsta: testPrVrsta;
  end;

var
  podlagaPrVrsta: TpodlagaPrVrsta;

implementation

{$R *.DFM}

procedure testPrVrsta.izpis (memo: tMemo);
  var
    n1, n2, konec: integer;
    vrsta: string;
begin
  memo.clear;
  if stEl>0 then
    for n1:=0 to trunc (log2 (stEl)) do begin
      vrsta:='';
      if stEl>=power (2, n1+1)-1 then konec:=round (power (2, n1+1)-1) else konec:=stEl;
      for n2:=round (power (2, n1)) to konec do vrsta:=vrsta+floatToStr (polje [n2].prioriteta)+' ('+intToStr (polje [n2].indeks)+') ';
      memo.lines.add (vrsta);
    end;
end;

procedure TpodlagaPrVrsta.btDodajClick(Sender: TObject);
  var el: element;
begin
  el:=element.create;
  el.prioriteta:=strToFloat (edPrioriteta.text);
  enaVrsta.dodaj (el);
  enaVrsta.izpis (mem);
end;

procedure TpodlagaPrVrsta.FormCreate(Sender: TObject);
begin
  podlagaPrVrsta.scaleBy (120, pixelsPerInch);
  enaVrsta:=testPrVrsta.create;
end;

procedure TpodlagaPrVrsta.FormDestroy(Sender: TObject);
begin
  enaVrsta.free;
end;

procedure TpodlagaPrVrsta.btBrisiClick(Sender: TObject);
  var el: element;
begin
  el:=enaVrsta.brisiMin;
  if el<>nil then edBrisal.text:=floatToStr (el.prioriteta);
  el.free;
  enaVrsta.izpis (mem);
end;

procedure TpodlagaPrVrsta.btZnizajPrClick(Sender: TObject);
  var n: integer;
begin
  for n:=1 to enaVrsta.stEl do if enaVrsta.polje [n].prioriteta=strToFloat (edPrioriteta.text) then begin
      enaVrsta.znizajPr (enaVrsta.polje [n], strToFloat (edNovaPr.text));
      break;
    end;
  enaVrsta.izpis (mem);
end;

procedure TpodlagaPrVrsta.btIzprazniClick(Sender: TObject);
begin
  enaVrsta.free;
  enaVrsta:=testPrVrsta.create;
  enaVrsta.izpis (mem);
end;

end.
